'*************************** Eieruhr-Ersatz ************************************
'
'Nach 1 min ertnt hohes Signal
'Nach 2 min ertnt tiefes Signal und AVR stoppt
'
'Zur Kontrolle blinkt LED (RV=560 Ohm) an PB0 im Sekundenrhythmus
'
'Taste "Start" an RESET PB5 (Pullup mit 50K)
'Taste "Stop" an INT0 = PB1 (eventuell mit 50k Pullup an Vcc)
'Piezoelectric-Buzzer ber 1k2 an PB2 und Vcc
'
'Stromaufnahme aktiv bei 3V Knopfzelle = ca. 80 uA
'                    bei 5V Goldcap = ca. 200uA
'Stromaufnahme im Powerdown-Modus = ca. 1,2uA
'
'*******************************************************************************

$regfile = "attiny13.dat"
$crystal = 600000                            'Clock 4.8MHz/8=600KHz
$hwstack = 8
$swstack = 2
$framesize = 24

'$sim

Dim Ticks As Byte
Dim Second As Byte
Dim Minute As Byte

Const Pulses_tone1 = 255 : Const Periods_tone1 = 40       '1-Minuten Ton,Pulses=Tondauer,Periods=Tonhhe.
Const Pulses_tone2 = 255 : Const Periods_tone2 = 255       '2-Minuten Ton

'***************************** START was pressed *******************************

Config Portb.0 = Output
Led Alias Portb.0                            'LED
Config Portb.2 = Output
Buzzer Alias Portb.2                         'Akustisches Signal bei 1 und 2 Min.

Config Portb.1 = Input                       'Stop-Switch to Ground
Portb.1 = 1                                  'Internen Pullup fr Input enablen

Config Int0 = Falling
On Int0 Int0_isr Nosave                      'Initialise the INT0 Interrupt
                                             '"Nosave" because Program stops here

Const Timer0reload = 108
Config Timer0 = Timer , Prescale = 1024      'The TIMER0 is started here automaticly

Stop Ac                                      'Analog Comparator aus:Strom sparen
Stop Adc                                     'ADC aus:Strom sparen
Stop Watchdog                                'Disable Watchdog:Strom sparen

On Ovf0 Tim0_isr Nosave                      'same as "On Timer0 Tim0_isr Nosave"
Load Timer0 , Timer0reload
Enable Timer0                                ' enable the timer interrupt
Enable Int0                                  'enable "Stop"-Button on INT0
Enable Interrupts                            'allow enabled interrupts to occur

Led = 1                                      'LED off
Sound Buzzer , Pulses_tone1 , Periods_tone1  'Start-Signal

Do

If Ticks = 5 Then                            'was an Interrupt here?
   Ticks = 0                                 'Yes,reset Interrupt-Flag
   Incr Second
       Led = 0                               'blink LED
       Waitms 30
       Led = 1
End If

If Second = 60 Then                          '1 Minute gone?
    Second = 0                               'yes
    Incr Minute                              'increase minutes
        If Minute = 2 Then Goto Timeout      'but stop after 2 Minutes
   Stop Timer0
   Sound Buzzer , Pulses_tone1 , Periods_tone1       '1 Minute warning Beep
   Waitms 100
   Sound Buzzer , Pulses_tone1 , Periods_tone1
   Waitms 100
   Sound Buzzer , Pulses_tone1 , Periods_tone1
   Start Timer0
End If

Idle                                         'enter Idle-Mode (saves Power)
Loop


Timeout:
Stop Timer0
Disable Interrupts
Ticks = 200                                  'Ticks,Second,Minute used as temporary Variables here
Second = 50                                  'because they are not used anymore !

For Minute = 1 To 5                          'Generate "I loose" sound
  Sound Buzzer , Ticks , Second
  Second = Second + 30
  Next Minute
Timeout2:                                    'Stop program
Power Powerdown                              'enter Powerdown-Mode
Goto Timeout2                                'never executes because clock is stopped (Powerdown!)

End                                          'End of all the shit above and below

'****************************** Timer0 Interrupt *******************************
Tim0_isr:                                    'every 200mS at 600KHz

$asm                                         ' save used registers first
Push R16
PUSH R24
PUSH R25
IN r24, SREG
PUSH R24
$end Asm

Load Timer0 , Timer0reload
  Ticks = Ticks + 1

$asm
POP R24                                      'now restore registers
Out Sreg , R24
pop R25
POP R24
POP R16
$end Asm

Return

'****************************** STOP was pressed *******************************
Int0_isr:

Stop Timer0
Disable Interrupts                           'Start again with "Reset"-Button
Led = 1                                      'Switch LED off
Ticks = Pulses_tone2 - 200                   'Ticks,Second used as temporary Variables here
Second = Periods_tone2 - 200                 'because they are not used anymore !
Sound Buzzer , Ticks , Second
Stop2:
Power Powerdown                              'enter Powerdown-Mode
Goto Stop2                                   'never executes because clock is stopped (Powerdown!)
Return